# Copyright © 2022 Alan Alexander Thomas <alan2000alex@gmail.com>

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
#
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from multiprocessing import get_context
from django.shortcuts import render

# Create your views here.
from re import template
from urllib import response
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth.password_validation import validate_password
from django.contrib.auth import authenticate, login, logout, get_user_model
from django.http import HttpResponse, HttpResponseRedirect
from django.views.decorators.csrf import csrf_protect
from django.core.exceptions import ValidationError

# Create your views here.
from django.http import HttpResponse


def index(request):
    return HttpResponse("Hello World.")


@csrf_protect
def register(request):
    # response = "You are at the Registration Page."
    get_context = {}
    if request.method == "GET":
        if "next" in request.GET:
            get_context["next"] = request.GET["next"]
        return render(request, "accounts/register.html", get_context)

    context = {}

    # variables
    email = request.POST["email"]
    password = request.POST["password"]
    password_confirm = request.POST["password-confirm"]

    # domain verification
    domain_check = email.split("@")
    if domain_check[1] != "vitap.ac.in":
        context["error"] = {
            "title": "Registration Failed",
            "reason": "We do not provide services for this domain yet.",
        }
        return render(request, "accounts/register.html", status=400, context=context)

    # email verification
    User = get_user_model()
    if User.objects.filter(email=email).exists():
        context["error"] = {
            "title": "Registration Failed",
            "reason": "This email is already registered.",
        }
        return render(request, "accounts/register.html", status=400, context=context)
    # password matching
    if password != password_confirm:
        context["error"] = {
            "title": "Registration Failed",
            "reason": "Passwords do not match.",
        }
        return render(request, "accounts/register.html", status=400, context=context)

    user = get_user_model()(
        username=domain_check[0],
        email=email,
    )
    user.set_password(password)

    try:
        user.full_clean()
        validate_password(password, user=user)
    except ValidationError as err:
        reason = ""
        for errors in err:
            reason += errors + " "
        context["error"] = {"title": "Registration Failed", "reason": reason}
        print(reason)
        return render(request, "accounts/register.html", status=400, context=context)

    user.save()
    return HttpResponse("New acc. can be registered.")
